#ifndef Photophoria_AlbumController_h
#define Photophoria_AlbumController_h

#include "Browser.h"
#include <wx/event.h>
class AlbumCanvas;
class AlbumInfoBook;
class MyFrame;

class wxTreeCtrl;
class wxTreeEvent;
class wxCommandEvent;
class wxPanel;

class AlbumController : public wxEvtHandler
{
public:
	AlbumController(MyFrame * pFrame, AlbumCanvas * pCanvas);
	void FinishLoad();

	enum Ordering { FOLDER, CALENDAR};
	void SetOrderingMode(Ordering order);

	void SelectAlbum(browser::AlbumInfo * pAlbum);
	
	void PopupMenu();
	void ShowPicture();

	// Album List Management
	virtual void AddAlbum(browser::AlbumInfo * pAlbum);
	void FillAlbumList();

	// InfoBook management
	void AlbumController::UpdateSelection();

	wxPanel * GetAlbumPanel(wxPanel * pParent);
	AlbumCanvas * GetCanvas();

protected:
	// This is how we get filled...
	friend wxPanel * GetAlbumPanel(wxPanel * pParent, AlbumController * pController);

	// PopupMenu event
	void OnSortCommand(wxCommandEvent & event);
	void OnThumbnailSizeCommand(wxCommandEvent & event);

    void NewAlbum (wxCommandEvent &event);
	void AlbumsOptions(wxCommandEvent & event);
    void OnAlbumClick (wxTreeEvent &event);

	Ordering currentOrdering;
	void SwitchOrderingMode();

	MyFrame * m_pFrame;
    wxTreeCtrl* m_pAlbumList;
	AlbumInfoBook * m_pInfoBook;
	AlbumCanvas * m_pCanvas;

    DECLARE_EVENT_TABLE()
};

#endif
