#ifndef Photophoria_AlbumInfoBook_h
#define Photophoria_AlbumInfoBook_h

#include <wx/control.h>

class wxPanel;
class wxToolBar;
class wxTreeCtrl;
class wxTreeEvent;
class wxCalendarCtrl;
class wxCalendarEvent;
class wxStaticText;

class AlbumCanvas;
class MyFrame;
class AlbumController;

class AlbumInfoBook : public wxControl
{
public:
	AlbumInfoBook (wxWindow *parent, AlbumController * pAlbumController, wxWindowID winid,  
				   const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0);

	void ChangeSelection(int n);
	void AddPage(wxWindow * page, const wxString &s, const wxBitmap &b);

	void UpdateExifTree();
	void UpdateCalendar(time_t t = -1);
	void UpdateSelectionInfo();

protected:
	AlbumController * m_pAlbumController;

	wxTreeCtrl * GetTagsTree();
	wxPanel * GetInfoPanel();
	wxTreeCtrl * GetExifTree();
	wxCalendarCtrl * GetCalendar();

	wxTreeCtrl * m_pTagsTree;
	wxTreeCtrl * m_pExifTree;
	wxPanel * m_pInfosPanel;
	wxCalendarCtrl * m_pCalendar;


	std::vector<wxStaticText * > m_infoTexts;

	// Books stuff&Events
	wxSize DoGetBestSize() const;
	void OnInfoPaneChange(wxCommandEvent &event);

	// Tags Events
	void BeginTagsDrag(wxTreeEvent &event);
	void OnTagsRightClick(wxTreeEvent &event);
	void OnTagsCommand(wxCommandEvent & event);

	// Calendar Events
	void OnCalendarMonthChange(wxCalendarEvent & event);
	void OnCalendarSelection(wxCalendarEvent & event);

	wxToolBar * m_pToolBar;
	std::vector <wxWindow *> m_pages;
	int m_selection;

    DECLARE_EVENT_TABLE()
};

#endif
