#ifndef Photophoria_AlbumPrefetch_h
#define Photophoria_AlbumPrefetch_h

#include <wx/thread.h>

class AlbumView;

class AlbumPrefetch : public wxThreadHelper
{
public:
	static AlbumPrefetch * Instance();

	void TryPrefetch(AlbumView * pView, int i, bool goingUp);
	void Stop(); // Stop the thread

protected:
	AlbumPrefetch();
	~AlbumPrefetch();
	virtual wxThread::ExitCode Entry(); // Entry point for the thread

	// What are we currently pre-fetching ?
	AlbumView * m_pAlbumView;
	int m_predict;
	bool m_prefetching;
	bool m_goingUp; 

	// threading synchronisation 
	wxMutex * m_pMutex;
	wxCondition * m_pCondition;
	bool m_exit; // indicates we should leave the thread
};

#endif
