#ifndef Photophoria_AlbumRendererWin32
#define Photophoria_AlbumRendererWin32

#include "AlbumView.h"

#ifdef USE_GDIPLUS
#define USE_GDIPLUS_ALBUM
#include "gdiplus.h"
#endif


class AlbumRenderer
{
public:
	AlbumRenderer(AlbumView *, wxDC & dc, int screen_width, int min_y, int max_y);
	~AlbumRenderer();

	void CreateDoubleBuffer();
	void DisplayDoubleBuffer();

	void DrawTitle(int origin);
	void DrawBitmap(void * pThumbnail, int x, int y);
	void DrawDropShadow(int x, int y, int tw, int th); 
	void DrawSelection (int x, int y, int tw, int th);
	void DrawTag (int x, int y, int tw, int th);

	static void FillScreen(wxDC & dc, int screen_pos); 
	static void DeleteBitmap(void * pThumbnail);

protected:
	int min_y, max_y;
	AlbumView * pAlbumView;

#ifdef USE_GDIPLUS_ALBUM
	Gdiplus::Graphics * pScreenGraphics;
	Gdiplus::Graphics * pBitmapGraphics;
	Gdiplus::Bitmap * pBitmap;
#else
	wxDC & screenDc;
	wxMemoryDC  * pBitmapDc;
	wxBitmap * m_pBitmap;
#endif

};
#endif
