#ifndef Photophoria_FilterPanel_h
#define Photophoria_FilterPanel_h

#include <wx/treectrl.h>
#include "Browser.h"

class ImageCanvas;
class GaugeControler;
class wxWindow;
class wxSlider;

namespace transform
{
	class Transform;
}


class FilterPanel : public wxPanel
{
public:
	FilterPanel(wxWindow * pParent, ImageCanvas * pImageCanvas, GaugeControler * pGaugeControler);
	~FilterPanel();

	void ActivateTransform(int t);
	wxPanel * CreateSliderPane();
	wxTreeCtrl * ConstructTree();

	static void ConstructExifTree(wxTreeCtrl * treeCtrl, browser::FileEntry * pEntry);

	void ExecuteTransform();
protected:
	void TryFilter (wxCommandEvent &event );
	void ApplyFilter (wxCommandEvent &event );
	void CancelFilter (wxCommandEvent &event );

    void OnTreeClick (wxTreeEvent &event );

	void AddTransform(transform::Transform * t, const std::string & name, wxTreeItemId id);

	std::vector <transform::Transform *> m_transforms;
	std::vector <wxSlider *> m_sliders;
	transform::Transform * m_currentTransform;

	ImageCanvas * m_pImageCanvas;
	GaugeControler * m_pGaugeControler;
	wxPanel * m_pSliderPanel;
	wxTreeCtrl * m_treeCtrl;
	int m_currentFilter;

    DECLARE_EVENT_TABLE()
};

#endif
