#ifndef Photophoria_ImageCanvas_h
#define Photophoria_ImageCanvas_h

//-----------------------------------------------------------------------------
// BrowserCanvas
//-----------------------------------------------------------------------------
#include <wx/scrolwin.h>

class GaugeControler;
class ImageRenderer;

namespace browser {
	struct FileEntry;
}

class ImageCanvas: public wxScrolledWindow
{
public:
	ImageCanvas() {}
	ImageCanvas( wxWindow *parent, wxWindowID, const wxPoint &pos, const wxSize &size );
	~ImageCanvas();

	virtual void LoadPicture(const browser::FileEntry * pFileEntry);
	virtual common::Image GetBaseImage();
	virtual void SetFilteredImage(common::Image & img);
	virtual void SaveFilteredImage() ;
	virtual void CancelFilteredImage() ;


protected:
	// Events:
	void OnEraseBackGround(wxEraseEvent& event);
	void OnResize(wxSizeEvent & event);
	void OnPaint( wxPaintEvent &event );
	void Clickage(wxMouseEvent & event);
	void MouseMotion(wxMouseEvent & event);

	double ConstrainZoom(double, wxSize * pSize = 0);
	GaugeControler * m_gaugeControler;
	double m_zoom;
	ImageRenderer * m_pRenderer;
	
	enum State { NO_PICTURE = 0, NO_CHANGE =1, MODIFIED = 2, APPLIED = 3};
	State m_state;
	bool m_moving; // indicates that we're either scrolling or zooming. 
	// In either case, the next 3 lines are set when the mouse button is first pressed.
	int m_viewPortStartX, m_viewPortStartY;
	int m_clickStartX, m_clickStartY;
	int m_centerStartX, m_centerStartY;
	double m_startingZoom;
	bool m_dirty;

	DECLARE_DYNAMIC_CLASS(ImageCanvas)
	DECLARE_EVENT_TABLE()
};

#endif
