#ifndef Photophoria_ImageRenderer_h
#define Photophoria_ImageRenderer_h

#include <wx/wx.h>

namespace browser {
	struct FileEntry;
}

#if defined (USE_GDIPLUS)
	namespace Gdiplus {
		class Bitmap;
	}
	typedef Gdiplus::Bitmap InnerBitmap;
#elif defined (USE_GTK_PIXBUF)
	typedef GdkPixbuf InnerBitmap;
#else
	typedef wxBitmap  InnerBitmap;
#endif

class ImageRenderer
{
public:
	ImageRenderer(wxWindow * targetWindow);

	void DeleteBitmap(unsigned int b);
	void ShiftBitmap(unsigned newPos, unsigned oldPos);
	void LoadBitmap(unsigned int pos, const browser::FileEntry * pFileEntry);

	void SetBitmap(unsigned int pos, const common::Image & image);
	common::Image GetBaseImage(unsigned int pos) const;
	void Paint(wxDC & dc, unsigned pos, float zoom, bool fast) const; //TODO: remove Alpha

	base::size GetWidth() const;
	base::size GetHeight() const;

protected:
	wxWindow * m_pTargetWindow;
	std::vector<InnerBitmap *> bitmaps;
};

#endif
