#ifndef Photophoria_MainFrame_h
#define Photophoria_MainFrame_h

#include <wx/frame.h>
#include <wx/treectrl.h>
#include <wx/calctrl.h>

//-----------------------------------------------------------------------------
// MyFrame
//-----------------------------------------------------------------------------

class FilterPanel;
class AlbumCanvas;
class ImageCanvas;

class wxFoldPanelBar;
class wxFlexGridSizer;
class wxBitmapButton;
class wxListBox;
class StatusBar;
class AlbumInfoBook;
class AlbumController;

namespace browser
{
	struct AlbumInfo;
}

class MyFrame: public wxFrame
{
public:
    MyFrame();
	~MyFrame();

    void OnQuit (wxCommandEvent &event );
    void ShowPicture ();
	void ShowAlbum();
	
	virtual void UpdateSelection();

protected:

	wxFlexGridSizer * m_topsizer;
	wxBoxSizer * m_pLeftSizer;
	StatusBar * m_pStatusBar;

	wxBitmapButton * m_pBmpAlbum, * m_pBmpImage;
	wxPanel  * m_pImagePanel, * m_pAlbumPanel;

	AlbumController  * m_pAlbumController;
	AlbumCanvas * m_albumCanvas;
	ImageCanvas	 *  m_imageCanvas;

	enum CurrentMode { ModeAlbum, ModePicture};
	CurrentMode currentMode;

	void SwapMainWindow(wxWindow * newWindow, wxWindow * oldWindow);
    void ShowPictureEvent (wxCommandEvent &event);
	void NextPicture(wxCommandEvent &event);

    DECLARE_EVENT_TABLE()
};
#endif
