class wxGauge;

class StatusBar : public wxStatusBar,  public GaugeControler
{
public:
    StatusBar(wxWindow *parent);
    virtual ~StatusBar();

	// Gauge progress:
	virtual void Enable(const std:: string & text);
	virtual void SetValue(int value);
	virtual void Disable();


private:
    // event handlers
    void OnSize(wxSizeEvent& event);

    wxGauge * m_gauge;
   
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(StatusBar, wxStatusBar)
    EVT_SIZE(StatusBar::OnSize)
END_EVENT_TABLE()


	enum
    {
        Field_Text,
        Field_Gauge,
        Field_Mode,
        Field_Max
    };

StatusBar::StatusBar(wxWindow *parent)
           : wxStatusBar(parent, wxID_ANY)
{

    static const int widths[Field_Max] = { -1, 147, 100 };

    SetFieldsCount(Field_Max);
    SetStatusWidths(Field_Max, widths);


	m_gauge = new wxGauge (this, -1, 100, wxDefaultPosition, wxDefaultSize,  wxGA_SMOOTH | wxGA_PROGRESSBAR);

	m_gauge->SetValue(0);

    SetMinHeight(16);

}


StatusBar::~StatusBar()
{

}

void StatusBar::OnSize(wxSizeEvent& event)
{

    wxRect rect;
    GetFieldRect(Field_Gauge, rect);
    m_gauge->SetSize(rect); 
    event.Skip();
}


void StatusBar::Enable(const std:: string & text) 
{
	m_gauge->Enable();
	m_gauge->SetValue(0);
	SetStatusText(text.c_str());
}

void StatusBar::SetValue(int value) 
{
       static int prevValue = 0;
       m_gauge->SetValue(value);
       if (value!=prevValue)
			common::Yield();
       prevValue=value;
}

void StatusBar::Disable() 
{
	m_gauge->SetValue(100);
	m_gauge->Disable();
	SetStatusText("Idle.");
	m_gauge->SetValue(0);
}


