#ifndef Photophoria_susan_h
#define Photophoria_susan_h

#include "transform.h"

namespace transform
{
    //////////////////////////////////////////////:
    // Susan : Smoothing over Univalue Segment Assimilating Nucleus
    //////////////////////////////////////////////:

    class Susan : public Transform
    {
    public:
        virtual const Controls & GetControls() const
        {
            static Controls controls;
             if (controls.empty())
            {
				controls.push_back(Control("Radius",  Control::FLOAT_SLIDER, 0.25f));
				controls.push_back(Control("Luminance",  Control::FLOAT_SLIDER, 0.3f));
				controls.push_back(Control("Chroma", Control::FLOAT_SLIDER, 0.5f));
            }
          return controls;    
        };
        
		virtual bool Execute(GaugeControler * pGaugeControler, 
							  const common::Image & in, common::Image & out, 
	       					 const transform::Parameters & params)
        {
			base::param d = 1+params[0].value*12.0;
			base::param b = 1+params[1].value*40.0;
  			base::param c = 1+params[2].value*50.0;
            DoSusan(pGaugeControler, in, out, d, b, c);
            return true; // cannot fail
        }    

		static void DoSusan(GaugeControler * pGaugeControler, const common::Image & image, common::Image & image2, 
							base::param distThreshold, base::param lumiThreshold, base::param colorThreshold);
    };    


} 
   
#endif

